﻿using System;
using SharpNeat.Network;
using SharpNeat.Utility;

namespace FaceDetection.Convolution
{
  public class ConvFunction : IActivationFunction
  {
    private readonly int inputs;

    public ConvFunction(int inputs)
    {
      this.inputs = inputs;
    }

    public string FunctionId
    {
      get { return GetType().Name; }
    }

    public string FunctionString
    {
      get { return String.Empty; }
    }

    public string FunctionDescription
    {
      get { return String.Empty; }
    }

    public bool AcceptsAuxArgs
    {
      get { return true; }
    }

    public double Calculate(double x, double[] auxArgs)
    {
      throw new NotImplementedException();
    }

    public float Calculate(float x, float[] auxArgs)
    {
      throw new NotImplementedException();
    }

    public double[] GetRandomAuxArgs(FastRandom rng, double connectionWeightRange)
    {
      var auxArgs = new double[inputs];
      for (int i = 0; i < auxArgs.Length; ++i)
      {
        auxArgs[i] = (rng.NextDouble() * 2 - 1) * connectionWeightRange;
      }
      return auxArgs;
    }

    public void MutateAuxArgs(double[] auxArgs, FastRandom rng, ZigguratGaussianSampler gaussian, double weightRange)
    {
      int selected = rng.Next(inputs);
      for (int i = 0; i < inputs; ++i)
      {
        if (i == selected || rng.Next(inputs) == 0)
        {
          double delta = gaussian.NextSample(0, rng.NextBool() ? 1 : 0.1);
          auxArgs[i] = Math.Min(weightRange, Math.Max(-weightRange, auxArgs[i] + delta));
        }
      }
    }
  }
}
